﻿using UnityEngine;
using System.Collections;

public class DoorOpener : MonoBehaviour {

	public ButtonType buttonType;
	public GameObject[] doors;
	public FloorButton exact;

	void OnEnable()
	{
		FloorButton.OnPress += WhenPress;
		FloorButton.OnRelease += WhenRelease;
	}

	void OnDisable()
	{
		FloorButton.OnPress -= WhenPress;
		FloorButton.OnRelease -= WhenRelease;
	}

	void WhenPress(FloorButton btn, HeroController hero)
	{
		if (btn.buttontype == buttonType && btn == exact)
		{
			for (int i = 0; i < doors.Length; i++)
			{
				doors[i].SetActive(false);
			}
		}
	}

	void WhenRelease(FloorButton btn, HeroController hero)
	{
		if (btn.buttontype == buttonType && btn == exact)
		{
			for (int i = 0; i < doors.Length; i++)
			{
				doors[i].SetActive(true);
			}
		}
	}
}
