﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class EnemyWalking : MonoBehaviour
{
	public List<GameObject> possibleMoves;
	public Transform myTransform;
	public GameObject myFroze;
	public Collider myCollider;
	public float speed = 2f;
	public float stayTime = 2f;
	public float frozeTime = 4f;
	public bool isFrozen = false;
	private Vector3 start;
	private Transform target;
	private Vector3 dir;
	private float tTime;
	private float cTime;

	public void Initialize ()
	{
		StartCoroutine(Move());
	}

	public void Freez()
	{
		StopAllCoroutines();
		myCollider.enabled = false;
		myFroze.SetActive(true);
		isFrozen = true;
	}

	void GetWay()
	{
		start = myTransform.position;
		cTime = 0f;
		target = possibleMoves[Random.Range(0, possibleMoves.Count)].transform;
		tTime = Vector3.Distance(myTransform.position, target.position) * speed;
		dir = target.position - start;

		myTransform.rotation = Quaternion.LookRotation(dir.normalized);
	}

	IEnumerator Move()
	{
		GetWay();
		while (cTime <= tTime)
		{
			myTransform.position = Vector3.Lerp(start, target.position, cTime / tTime);
			cTime += Time.deltaTime;
			yield return null;
		}
		StartCoroutine(Wait());
	}

	IEnumerator Wait()
	{
		yield return new WaitForSeconds(stayTime);
		StartCoroutine(Move());
	}

	[ContextMenu("fill1")]
	void Fill1()
	{
		possibleMoves = GameObject.FindObjectOfType<LevelMap>().landHero1;
	}

	[ContextMenu("fill2")]
	void Fill2()
	{
		possibleMoves = GameObject.FindObjectOfType<LevelMap>().landHero2;
	}
}
