﻿using UnityEngine;
using System.Collections;
using System;

public enum ButtonType : int
{
	Cross = 0,
	Square = 1,
	Triangle = 2,
	Circle = 4,
	Plane = 5
}

public class FloorButton : MonoBehaviour {

	public static Action<FloorButton, HeroController> OnPress;
	public static Action<FloorButton, HeroController> OnRelease;

	public ButtonType buttontype;
	public bool interactale = true;
	public Animator targetAnimator;
	public string keyPress = "on";
	public string keyRelease = "off";
	public bool isPressed { get { return _isPressed; } }

	private bool _isPressed = false;

	void OnTriggerEnter(Collider other)
	{
		HeroController hero = other.gameObject.GetComponent<HeroController>();
		if (hero != null)
		{
			_isPressed = true;
			if (targetAnimator != null)
				targetAnimator.SetTrigger(keyPress);
			if (OnPress != null)
				OnPress(this, hero);
		}
	}

	void OnTriggerExit(Collider other)
	{
		HeroController hero = other.gameObject.GetComponent<HeroController>();
		if (hero != null)
		{
			_isPressed = false;
			if (targetAnimator != null)
				targetAnimator.SetTrigger(keyRelease);
			if (OnRelease != null)
				OnRelease(this, hero);
		}
	}
}
