﻿using UnityEngine;
using System.Collections;

public class HeroController : MonoBehaviour {

	public int lives = 3;
	public bool enableControll = true;

	public float walkSpeed = 1f;
	public GameObject prefabBullet;

	public Collider myCollider;
	public Transform myTransform;
	public Rigidbody myRigidBody;
	public Renderer myRenderer;
	public Transform targetCircle;
	public string keyIVertical = "Vertical";
	public string keyIHorizontal = "Horizontal";
	public string keyIFire = "Fire1";

	public WeaponType weapon;

	private Transform targetFollow;
	private float iptHorizontal = 0f;
	private float iptVertical = 0f;
	private bool iptFire = false;
	private float invTime = 4f;
	
	public void Spawn()
	{
		StartCoroutine(CoInvSpawn());
	}
	IEnumerator CoInvSpawn()
	{
		myCollider.enabled = false;
		float cTime = 0f;
		while (cTime < invTime)
		{
			Color c= Color.white;
			c.a = Mathf.Clamp01(cTime * invTime % 2);
			myRenderer.material.SetColor("_Color", c);
			cTime += Time.deltaTime;
			yield return null;
		}
		myRenderer.material.SetColor("_Color", Color.white);
		myCollider.enabled = true;
	}

	public void SetFollow(Transform target)
	{
		targetFollow = target;
	}

	void Update ()
	{
		if (enableControll)
		{
			this.iptHorizontal = Input.GetAxis(this.keyIHorizontal);
			this.iptVertical = Input.GetAxis(this.keyIVertical);
			this.iptFire = Input.GetButton(this.keyIFire);

			if (this.iptFire)
			{
				MakeFire();
			}
		}

	}

	void FixedUpdate()
	{
		myRigidBody.velocity = Vector3.zero;
		Vector3 pos = myTransform.position;
		Vector3 dir = new Vector3(this.iptHorizontal, 0f, this.iptVertical);
		pos += dir.normalized * walkSpeed * Time.deltaTime;

		if (dir != Vector3.zero)
		{
			Quaternion rot = Quaternion.LookRotation(dir.normalized, Vector3.up);
			myTransform.rotation = rot;
		}
		myTransform.position = pos;
		myRigidBody.MovePosition(pos);

		if (targetFollow != null)
		{
			dir = myTransform.position - targetFollow.position;
			dir.y = 0f;
			Quaternion q = Quaternion.LookRotation(dir);
			targetCircle.position = myTransform.position;
			targetCircle.rotation = q;
		}
		else
		{
			if (targetCircle != null && targetCircle.gameObject.activeSelf)
				targetCircle.gameObject.SetActive(false);
		}
	}

	void MakeFire()
	{
		if (weapon != null)
			weapon.Fire();
	}


}
