﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class InGameUI : MonoBehaviour {

	public HeroController hero1;
	public HeroController hero2;
	public List<Image> livesHero1;
	public List<Image> livesHero2;
	public Slider lvlProgress;
	public Color colorOff;
	public GameObject rootDialog;
	public Text dialogText;
	public float dialogStay = 3f;
	public Image imgWilliam;
	public Image imgJuliet;
	public Image imgRomeo;
	private List<string> dialogQuery = new List<string>();
	private Coroutine cDialog;

	void OnEnable()
	{
		LogicBase.OnRightMove += WhenRightMove;
		LogicBase.OnHeroDie += WhenHeroDie;
		LogicBase.OnDialog += WhenDialog;
	}

	void OnDisable()
	{
		LogicBase.OnRightMove -= WhenRightMove;
		LogicBase.OnHeroDie -= WhenHeroDie;
		LogicBase.OnDialog -= WhenDialog;
	}

	void WhenRightMove(LogicBase logic)
	{
		float progress = (float)logic.iteration / logic.rightIndicator.Length;
		lvlProgress.value = progress;
	}

	void WhenHeroDie(HeroController hero)
	{
		if (hero == hero1)
		{
			if (livesHero1.Count > 0)
			{
				Destroy(livesHero1[0].gameObject);
				livesHero1.RemoveAt(0);
			}
		}
		else if (hero == hero2)
		{
			if (livesHero2.Count > 0)
			{
				Destroy(livesHero2[0].gameObject);
				livesHero2.RemoveAt(0);
			}
		}
	}

	void WhenDialog(string key)
	{
		dialogQuery.Add(key);
		if (cDialog == null)
			cDialog = StartCoroutine(CoDialog());
	}


	IEnumerator CoDialog()
	{
		while(dialogQuery.Count > 0)
		{
			switch(dialogQuery[0].ToCharArray()[0])
			{
				case 'W':
					imgWilliam.enabled = true;
					imgRomeo.enabled= false;
					imgRomeo.enabled = false;
					break;
				case 'J':
					imgWilliam.enabled = false;
					imgRomeo.enabled= false;
					imgJuliet.enabled = true;
					break;
				case 'R':
					imgWilliam.enabled = false;
					imgRomeo.enabled= true;
					imgJuliet.enabled = false;
					break;
			}

			rootDialog.SetActive(true);
			dialogText.text = PiLang.Localize(dialogQuery[0]);
			dialogQuery.RemoveAt(0);
			yield return new WaitForSeconds(dialogStay);
			rootDialog.SetActive(false);
			yield return new WaitForSeconds(1f);
		}
	}
}
