﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class LangMenu : MonoBehaviour {
	public Toggle En;
	public Toggle Ru;

	void Awake ()
	{
		PiLang.Initialize();
	}

	void Start()
	{
		if (PiLang.GetCurrentLanguage() == SystemLanguage.Russian)
		{
			En.isOn = true;
		}
		else
		{
			Ru.isOn = true;
		}
	}

	void OnEnable()
	{
		En.onValueChanged.AddListener(WhenEn);
		Ru.onValueChanged.AddListener(WhenRu);

	}

	void OnDisable()
	{
		En.onValueChanged.RemoveListener(WhenEn);
		Ru.onValueChanged.RemoveListener(WhenRu);
	}

	void WhenEn(bool on)
	{
		if (on)
			PiLang.SetLanguage(SystemLanguage.English);
		//Debug.Log("f");
	}

	void WhenRu(bool on)
	{
		if (on)
			PiLang.SetLanguage(SystemLanguage.Russian);
	}

}
