﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class LevelMap : MonoBehaviour {

	public int x = 20;
	public int z = 20;
	public int xminHero1 = 0;
	public int xmaxHero1 = 5;
	public int xminHero2 = 8;
	public int xmaxHero2 = 13;
	public float minY = -0.1f;
	public float maxY = 0.1f;
	public float scalex = 2f;
	public float scalez = 2f;
	public GameObject[] prefabLand;
	public List<GameObject> createdLand = new List<GameObject>();
	public List<GameObject> landHero1 = new List<GameObject>();
	public List<GameObject> landHero2 = new List<GameObject>();

	[ContextMenu("Take Fill")]
	void Fill()
	{
		GameObject go;
		int id;

		Clear();

		for (int i = 0; i < x; i++)
		{
			for (int j = 0; j < z; j++)
			{
				id = Random.Range(0, prefabLand.Length);
				//Quaternion rot = prefabLand[id].transform.rotation;
				//rot.eulerAngles = new Vector3(0f, 90 * Random.Range(0, 3), 0f);
				go = Instantiate(prefabLand[id], transform.position + new Vector3((float)i * scalex, Random.Range(minY, maxY), (float)j * scalez), Quaternion.identity) as GameObject;
				go.transform.parent = transform;
				go.name = string.Format("{0}{1}", i, j);
				createdLand.Add(go);
				if (i >= xminHero1 && i< xmaxHero1)
					landHero1.Add(go);
				if (i >= xminHero2 && i< xmaxHero2)
					landHero2.Add(go);
				
			}
		}
	}

	[ContextMenu("Take Clear")]
	void Clear()
	{
		for (int i = 0; i < createdLand.Count; i++)
			DestroyImmediate(createdLand[i]);
		createdLand.Clear();
		landHero1.Clear();
		landHero2.Clear();
	}
}
