﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Logic01 : LogicBase
{
	public PointMover[] rockMovers;
	public GameObject[] prefabButton;
	public LevelMap levelMap;

	public GameObject offGO1;
	public GameObject offGO2;
	public FloorButton onB1;
	public FloorButton onB2;

	protected override void Initialize ()
	{
		base.Initialize ();
		FloorButton.OnPress += WhenButtonPress;
	}

	protected override void DeInitialize()
	{
		base.DeInitialize ();
		FloorButton.OnPress -= WhenButtonPress;
	}

	public override void StartPlay ()
	{
		base.StartPlay ();
		for (int i = 0; i < rockMovers.Length; i++)
			rockMovers[i].Initialize();
		RightMove();
	}

	void WhenButtonPress(FloorButton b, HeroController hero)
	{
		if (onB1 != null && onB2 != null && onB1.isPressed && onB2.isPressed)
			RightMove();
	}

	public override void RightMove ()
	{
		base.RightMove ();

		if (offGO1 != null)
			offGO1.SetActive(true);
		if (offGO2 != null)
			offGO2.SetActive(true);

		if (onB1 != null)
			Destroy(onB1.gameObject);
		if (onB2 != null)
			Destroy(onB2.gameObject);

		if (iterationID < rightIndicator.Length)
		{
			offGO1 = levelMap.landHero1[Random.Range(0, levelMap.landHero1.Count)];
			offGO2 = levelMap.landHero2[Random.Range(0, levelMap.landHero2.Count)];
			offGO1.SetActive(false);
			offGO2.SetActive(false);

			GameObject go1, go2;
			go1 = Instantiate(prefabButton[iterationID], offGO1.transform.position, offGO1.transform.rotation) as GameObject;
			go2 = Instantiate(prefabButton[iterationID], offGO2.transform.position, offGO2.transform.rotation) as GameObject;
			onB1 = go1.GetComponent<FloorButton>();
			onB2 = go2.GetComponent<FloorButton>();
			hero1.SetFollow(offGO1.transform);
			hero2.SetFollow(offGO2.transform);
		}
		else
		{
			hero1.SetFollow(null);
			hero2.SetFollow(null);
		}
	}
}
