﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;
using System.Collections.Generic;

public class SceneFader : PiScene
{
    public enum Scenes : byte
    {
        Preload = 0,
        Mainmenu = 1,
        Play = 2
    }

    public GameObject windowLoadingLogo;
    public Image[] spriteFade;
    public Text textLoading;
    public string keyLoading = "LOADING";

    private bool _blackLock = false;

    protected override void FadeIn(float value)
    {
        base.FadeIn(value);

        if (!windowLoadingLogo.activeSelf)
            windowLoadingLogo.SetActive(true);

        Color c;

        for (int i = 0; i < spriteFade.Length; ++i)
        {
            c = spriteFade[i].color;
            c.a = value;
            spriteFade[i].color = c;
        }

        if (value >= 1f)
        {
            textLoading.text = PiLang.Localize(keyLoading);
            textLoading.enabled = true;
            _blackLock = true;
        }
    }

    protected override void Black(float value)
    {
        base.Black(value);

        if (_blackLock)
        {
            _blackLock = false;
        }

        if (value >= 1f)
		{
            textLoading.enabled = false;
        }
    }

    protected override void FadeOut(float value)
    {
        base.FadeOut(value);
        
        Color c;
        for (int i = 0; i < spriteFade.Length; ++i)
        {
            c = spriteFade[i].color;
            c.a = 1f - value;
            spriteFade[i].color = c;
        }
    }

    protected override void White(float value)
    {
        base.White(value);

        if (windowLoadingLogo.activeSelf)
            windowLoadingLogo.SetActive(false);
    }
}