﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class PickWeapon : WeaponType
{
	public List<GameObject> canPickUp;
	public List<GameObject> show;
	public Transform pickParent;
	public GameObject picked;
	public Transform loose;


	public override void Fire ()
	{
		for (int i = 0; i < canPickUp.Count; i++)
		{
			EnemyWalking e = canPickUp[i].GetComponent<EnemyWalking>();
			if (e != null && e.isFrozen && picked == null)
			{
				e.myTransform.parent = pickParent;
				e.myTransform.position = pickParent.position;
				e.myTransform.rotation = pickParent.rotation;
				picked = e.gameObject;
			}
		}

		base.Fire ();
	}

	void Update()
	{
		if (picked != null)
		if (Vector3.Distance(loose.position, picked.transform.position) < range)
		{
			LogicBase.instance.RightMove();
			show[0].SetActive(true);
			show.RemoveAt(0);
			canPickUp.Remove(picked);
			Destroy(picked);
		}
	}
}
