﻿using UnityEngine;
using System.Collections;

public class PointMover : MonoBehaviour 
{
	public Transform start;
	public Transform finish;
	public Transform moveTransform;
	public bool byCycle = false;
	public bool waitOnStart = false;
	public float minTime = 3f;
	public float maxTime = 3f;
	public float waitTimeMin = 6f;
	public float waitTimeMax = 6f;

	void OnEnable()
	{
	}

	void OnDisable()
	{
	}

	public void Initialize()
	{
		StartCoroutine(CoMove());
	}

	public void DeInitialize()
	{
		StopAllCoroutines();
	}

	IEnumerator CoMove()
	{
		float cTime = 0f;
		float tTime = Random.Range(minTime, maxTime);
		float wTime = Random.Range(waitTimeMin, waitTimeMax);
		float pTime = 0f;
		while (true)
		{
			if (waitOnStart)
				yield return new WaitForSeconds(wTime);
			
			cTime += Time.deltaTime;
			pTime = cTime / tTime;
			TickMove(pTime);
			if (byCycle && pTime >= 1f)
			{
				cTime = 0f;
				tTime = Random.Range(minTime, maxTime);
				wTime = Random.Range(waitTimeMin, waitTimeMax);
				if (wTime > 0f)
					yield return new WaitForSeconds(wTime);
			}
			yield return null;
		}
	}

	void TickMove(float p)
	{
		moveTransform.position = Vector3.Lerp(start.position, finish.position, p);
	}


}
