﻿using UnityEngine;
using System.Collections;

public enum TickType : int
{
	Update = 0,
	FixedUpdate = 1
}
public class Rotator : MonoBehaviour {

	public TickType tickType;
	public Vector3 axis = new Vector3(0f, 1f, 0f);
	public float speed = 90f;
	public Transform targetTransform;
	public Rigidbody targetRigidbody;
	public bool startWithRndRotation = true;

	void Start()
	{
		if (startWithRndRotation)
		{
			Vector3 start = new Vector3(axis.x * Random.Range(0f, 366f), axis.y * Random.Range(0f, 360f), axis.z * Random.Range(0f, 360f));
			targetTransform.eulerAngles = start;
		}
	}

	void Update()
	{
		if (tickType == TickType.Update)
		{
			targetTransform.Rotate(axis * speed * Time.deltaTime);
		}
	}

	void FixedUpdate()
	{
		if (tickType == TickType.FixedUpdate)
		{
			targetRigidbody.MoveRotation(Quaternion.Euler(axis * speed * Time.deltaTime));
		}
	}

	[ContextMenu("myOwn")]
	void Fill()
	{
		targetTransform = GetComponent<Transform>();
		targetRigidbody = GetComponent<Rigidbody>();
	}
}
